package com.jiuqi.db;

import java.util.Calendar;
import java.util.Date;

public abstract class DBFunction {
   private static final String left_parenthesis = "(";
   private static final String right_parenthesis = ")";
   private static final String comma = ",";
   private static final String FUNC_NAME_ABS = "ABS";
   private static final String FUNC_NAME_ACOS = "ACOS";
   private static final String FUNC_NAME_ASIN = "ASIN";
   private static final String FUNC_NAME_ATAN = "ATAN";
   private static final String FUNC_NAME_ATAN2 = "ATAN2";
   private static final String FUNC_NAME_COS = "COS";
   private static final String FUNC_NAME_EXP = "EXP";
   private static final String FUNC_NAME_FLOOR = "FLOOR";
   private static final String FUNC_NAME_POWER = "POWER";
   private static final String FUNC_NAME_ROUND = "ROUND";
   private static final String FUNC_NAME_SIGN = "SIGN";
   private static final String FUNC_NAME_SIN = "SIN";
   private static final String FUNC_NAME_LOWER = "LOWER";
   private static final String FUNC_NAME_LTRIM = "LTRIM";
   private static final String FUNC_NAME_REPLACE = "REPLACE";
   private static final String FUNC_NAME_RTRIM = "RTRIM";
   private static final String FUNC_NAME_UPPER = "UPPER";
   private static final String FUNC_NAME_ASCII = "ASCII";
   private StringBuffer formatbuffer = new StringBuffer();

   protected String format(String functionName, String expression) {
      this.formatbuffer.setLength(0);
      this.formatbuffer.append(functionName);
      this.formatbuffer.append("(");
      this.formatbuffer.append(expression);
      this.formatbuffer.append(")");
      return this.formatbuffer.toString();
   }

   protected String format(String functionName, String expression1, String expression2) {
      this.formatbuffer.setLength(0);
      this.formatbuffer.append(functionName);
      this.formatbuffer.append("(");
      this.formatbuffer.append(expression1);
      this.formatbuffer.append(",");
      this.formatbuffer.append(expression2);
      this.formatbuffer.append(")");
      return this.formatbuffer.toString();
   }

   protected String format(String functionName, String expression1, String expression2, String expression3) {
      this.formatbuffer.setLength(0);
      this.formatbuffer.append(functionName);
      this.formatbuffer.append("(");
      this.formatbuffer.append(expression1);
      this.formatbuffer.append(",");
      this.formatbuffer.append(expression2);
      this.formatbuffer.append(",");
      this.formatbuffer.append(expression3);
      this.formatbuffer.append(")");
      return this.formatbuffer.toString();
   }

   protected String formatmidopt(String expression1, String operationSymbol, String expression2) {
      this.formatbuffer.setLength(0);
      this.formatbuffer.append(expression1);
      this.formatbuffer.append(operationSymbol);
      this.formatbuffer.append(expression2);
      return this.formatbuffer.toString();
   }

   public abstract String strLinkSymbol();

   public abstract boolean supportEmptyString();

   public String abs(String numeric_expression) {
      return this.format("ABS", numeric_expression);
   }

   public String acos(String numeric_expression) {
      return this.format("ACOS", numeric_expression);
   }

   public String asin(String numeric_expression) {
      return this.format("ASIN", numeric_expression);
   }

   public String atan(String numeric_expression) {
      return this.format("ATAN", numeric_expression);
   }

   public String atan2(String expression) {
      return this.format("ATAN2", expression);
   }

   public abstract String ceiling(String var1);

   public String cos(String numeric_expression) {
      return this.format("COS", numeric_expression);
   }

   public String exp(String numeric_expression) {
      return this.format("EXP", numeric_expression);
   }

   public String floor(String expression) {
      return this.format("FLOOR", expression);
   }

   public abstract String ln(String var1);

   public abstract String log10(String var1);

   public abstract String mod(String var1, String var2);

   public String power(String numeric_expression1, String numeric_expression2) {
      return this.format("POWER", numeric_expression1, numeric_expression2);
   }

   public String round(String numeric_expression) {
      return this.round(numeric_expression, "0");
   }

   public String round(String numeric_expression, String int_expression) {
      return this.format("ROUND", numeric_expression, int_expression);
   }

   public String sign(String numeric_expression) {
      return this.format("SIGN", numeric_expression);
   }

   public String sin(String numeric_expression) {
      return this.format("SIN", numeric_expression);
   }

   public abstract String chr(String var1);

   public abstract String pos(String var1, String var2);

   public abstract String left(String var1, String var2);

   public String lower(String str_expression) {
      return this.format("LOWER", str_expression);
   }

   public String ltrim(String str_expression) {
      return this.format("LTRIM", str_expression);
   }

   public String replace(String source_str_expression, String search_str_expression, String replace_str_expression) {
      return this.format("REPLACE", source_str_expression, search_str_expression, replace_str_expression);
   }

   public abstract String right(String var1, String var2);

   public String rtrim(String str_expression) {
      return this.format("RTRIM", str_expression);
   }

   public abstract String str(String var1);

   public abstract String substr(String var1, String var2, String var3);

   public String upper(String str_expression) {
      return this.format("UPPER", str_expression);
   }

   public String ascii(String char_expression) {
      return this.format("ASCII", char_expression);
   }

   public abstract String len(String var1);

   public abstract String val(String var1);

   public String date(Calendar dateVal) {
      Date d = dateVal.getTime();
      return this.date(d);
   }

   public abstract String date(Date var1);
}
